Lattice Grid Buy a licence

demo D229

Pushdown to a live OData service

A grid over the public Northwind service; filter and sort are pushed to it, and lastPlan shows the split

createPushdownSource · odataAdapter · lastPlan()

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import * as Lattice from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { createGrid, createPushdownSource, odataAdapter } = Lattice;
const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// The adapter takes a URL and imports nothing. createPushdownSource turns the
// grid's query into an OData request and finishes any residual in the grid.
const adapter = odataAdapter({
  url: 'https://services.odata.org/V4/Northwind/Northwind.svc/Orders',
});
const source = createPushdownSource({
  adapter,
  compute: Lattice,   // the grid's own kernels, for anything the service could not do
  pageSize: 100,
});

const columns = [
  { field: 'OrderID', title: 'Order', type: 'number' },
  { field: 'CustomerID', title: 'Customer', filter: { type: 'set' } },
  { field: 'ShipCountry', title: 'Ship to', filter: { type: 'set' } },
  { field: 'Freight', title: 'Freight', type: 'number' },
  { field: 'OrderDate', title: 'Ordered', type: 'dateString' },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" (rows-changed)="onRowsChanged()" style="display:block;height:520px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'OrderID',
    toolPanel: { side: 'left', panels: ['filters', 'columns'] },
    columns,
    source,
  };

  // After each query, lastPlan() reports what the service ran and what stayed here.
  onRowsChanged() {
    const plan = source.lastPlan();
    if (plan) console.log(plan.unpushed.length ? 'pushed part' : 'pushed all', plan);
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D229

Pushdown to a live OData service

A grid over the public Northwind service; filter and sort are pushed to it, and lastPlan shows the split

createPushdownSource · odataAdapter · lastPlan()

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import * as Lattice from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const { createGrid, createPushdownSource, odataAdapter } = Lattice;
  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // The adapter takes a URL and imports nothing. createPushdownSource turns the
  // grid's query into an OData request and finishes any residual in the grid.
  const adapter = odataAdapter({
    url: 'https://services.odata.org/V4/Northwind/Northwind.svc/Orders',
  });
  const source = createPushdownSource({
    adapter,
    compute: Lattice,   // the grid's own kernels, for anything the service could not do
    pageSize: 100,
  });

  const columns = [
    { field: 'OrderID', title: 'Order', type: 'number' },
    { field: 'CustomerID', title: 'Customer', filter: { type: 'set' } },
    { field: 'ShipCountry', title: 'Ship to', filter: { type: 'set' } },
    { field: 'Freight', title: 'Freight', type: 'number' },
    { field: 'OrderDate', title: 'Ordered', type: 'dateString' },
  ];

  function App() {
    // After each query, lastPlan() reports what the service ran and what stayed here.
    const onRowsChanged = () => {
      const plan = source.lastPlan();
      if (plan) console.log(plan.unpushed.length ? 'pushed part' : 'pushed all', plan);
    };

    return (
      <LatticeGrid
        rowKey="OrderID"
        toolPanel={{ side: 'left', panels: ['filters', 'columns'] }}
        columns={columns}
        source={source}
        onRowsChanged={onRowsChanged}
        style={{ height: '520px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>